Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp	(revision 122)
@@ -33,13 +33,14 @@
         log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * BRANCH_COMPLETE [%d]",i);
 
-	Tcontext_t          context   = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
-	Tdepth_t            depth     = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
-	Tcontrol_t          miss      = false;
-	Tcontrol_t          take      = reg_UPDATE_PREDICTION_TABLE [context][depth]._last_take   ;
-	Taddress_t          addr_dest = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest;
-	Tbranch_condition_t condition = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition   ;
+        // Read information
+	Tcontext_t          context     = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
+	Tdepth_t            depth       = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
+	Tcontrol_t          miss        = false; // init
+	Tcontrol_t          take        = reg_UPDATE_PREDICTION_TABLE [context][depth]._last_take   ;
+	Taddress_t          addr_dest   = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest;
+	Tbranch_condition_t condition   = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition   ;
 
         Tcontrol_t          no_sequence = PORT_READ(in_BRANCH_COMPLETE_NO_SEQUENCE [i]);
-        Taddress_t          addr_good = PORT_READ(in_BRANCH_COMPLETE_ADDRESS [i]);
+        Taddress_t          addr_good   = PORT_READ(in_BRANCH_COMPLETE_ADDRESS [i]);
 
         log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context        : %d",context);
@@ -54,4 +55,5 @@
         log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * address_dest : %.8x",addr_dest);
 
+        // Test branch condition
 	switch (condition)
 	  {
@@ -80,6 +82,4 @@
               log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * BRANCH_CONDITION_FLAG");
 
-//               Tcontrol_t take_good = not flag; // flag set = not take
-//               Tcontrol_t take_good = flag; // flag set = take
               Tcontrol_t take_good = no_sequence;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_decod.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_decod.cpp	(revision 122)
@@ -28,37 +28,39 @@
     if (PORT_READ(in_NRESET) != 0)
       {
+    // for each decod instruction
     for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
       {
         log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * DECOD [%d]",i);
 
-        Tcontext_t    context     = (_param->_have_port_context_id)?PORT_READ(in_DECOD_CONTEXT_ID [i]):0;
-        bool          is_accurate = _param->_accurate_block_decod or reg_IS_ACCURATE [context];
-        event_state_t event_state = reg_EVENT_STATE [context];
-        uint32_t      ptr_write   = reg_UPT_TOP     [context];
-        // can continue if next slot is empty
-        Tcontrol_t    can_continue= ((reg_UPDATE_PREDICTION_TABLE [context][(reg_UPT_TOP [context]+1)%_param->_size_upt_queue[context]]._state == UPDATE_PREDICTION_STATE_EMPTY) and 
-                                     (reg_EVENT_STATE [context] == EVENT_STATE_OK));
+        // Read information
+        Tcontext_t         context          = (_param->_have_port_context_id)?PORT_READ(in_DECOD_CONTEXT_ID [i]):0;
+        bool               is_accurate      = (_param->_always_accurate_decod or 
+                                              (_param->_can_accurate_decod and reg_IS_ACCURATE [context]));
+        upt_event_state_t  upt_event_state  = reg_UPT_EVENT_STATE  [context];
+        ufpt_event_state_t ufpt_event_state = reg_UFPT_EVENT_STATE [context];
+        uint32_t           ptr_write        = reg_UPT_TOP     [context]; // One branch per context per cycle
+        uint32_t           ptr_write_next   = (ptr_write+1)%_param->_size_upt_queue[context];
+        // Decod can continue until the next branch if next slot is empty, and no event
+        Tcontrol_t         can_continue     = (reg_UPDATE_PREDICTION_TABLE [context][ptr_write_next]._state == UPDATE_PREDICTION_STATE_EMPTY);
 
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * context     : %d",context    );
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * is_accurate : %d",is_accurate);
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * event_state : %s",toString(event_state).c_str());
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ptr_write   : %d",ptr_write  );
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * upt_state   : %s",toString(reg_UPDATE_PREDICTION_TABLE [context][ptr_write]._state).c_str());
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * can_continue: %d",can_continue);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * context          : %d",context);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * is_accurate      : %d",is_accurate);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ufpt_event_state : %s",toString(ufpt_event_state).c_str());
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * upt_event_state  : %s",toString(upt_event_state).c_str());
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ptr_write        : %d - %d",ptr_write,ptr_write_next);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * upt_state        : %s",toString(reg_UPDATE_PREDICTION_TABLE [context][ptr_write]._state).c_str());
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * can_continue     : %d",can_continue);
 
-        // ack :
+        // can decod (ack) if :
         //   * in all case (miss or hit), need empty slot
+        //   * not previous event (state = ok)
         //   * is_accurate
-        //   * event_state : don't update upt
         internal_DECOD_ACK           [i] = ((reg_UPDATE_PREDICTION_TABLE [context][ptr_write]._state == UPDATE_PREDICTION_STATE_EMPTY) and
-                                            is_accurate and
-//                                             (
-                                             (event_state == EVENT_STATE_OK)//  or
-//                                              (event_state == EVENT_STATE_MISS_FLUSH_UFPT    ) or
-//                                              (event_state == EVENT_STATE_UPDATE_CONTEXT))
-                                            );
+                                            (ufpt_event_state == UFPT_EVENT_STATE_OK) and
+                                            (upt_event_state  == UPT_EVENT_STATE_OK ) and
+                                            is_accurate);
         internal_DECOD_UPT_PTR_WRITE [i] = ptr_write;
 
-        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ack         : %d",internal_DECOD_ACK [i]);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ack              : %d",internal_DECOD_ACK [i]);
 
 	PORT_WRITE(out_DECOD_ACK          [i], internal_DECOD_ACK [i]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_predict.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_predict.cpp	(revision 122)
@@ -27,9 +27,10 @@
     if (PORT_READ(in_NRESET) != 0)
       {
-
+    // For each prediction
     for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
       {
+        // Read information
 	Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_PREDICT_CONTEXT_ID [i]):0;
-	uint32_t   top     = reg_UFPT_TOP[context];
+	uint32_t   top     = reg_UFPT_TOP[context]; // not multi branch prediction
 
 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"PREDICT [%d] (genMealy)",i);
@@ -40,23 +41,23 @@
 // 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * need update : %d",reg_NB_ELT_NEED_UPDATE [context]);
 
+        bool is_accurate = (_param->_always_accurate_predict or 
+                            (_param->_can_accurate_predict and reg_IS_ACCURATE [context]));
+
+        // Ack if :
+        //  * no previous event (ufpt and upt is ok)
+        //  * top slot is empty
+        //  * is_accurate
+	internal_PREDICT_ACK [i] = ((reg_UFPT_EVENT_STATE [context] == UFPT_EVENT_STATE_OK) and
+                                    (reg_UPT_EVENT_STATE  [context] == UPT_EVENT_STATE_OK ) and
+                                    (reg_UPDATE_FETCH_PREDICTION_TABLE [context][top]._state == UPDATE_FETCH_PREDICTION_STATE_EMPTY) and
+                                    is_accurate);
+
         internal_PREDICT_UPDATE_PREDICTION_ID [i] = top;
 
+ 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ACK         : %d",internal_PREDICT_ACK [i]);
+
+	PORT_WRITE(out_PREDICT_ACK                  [i], internal_PREDICT_ACK                  [i]);
         if (_param->_have_port_depth)
         PORT_WRITE(out_PREDICT_UPDATE_PREDICTION_ID [i], internal_PREDICT_UPDATE_PREDICTION_ID [i]);
-
-        bool is_accurate = _param->_accurate_block_predict or reg_IS_ACCURATE[context];
-
-        // Ack if :
-        //  * slot is empty
-        //  * no previous miss
-        //  * is_accurate
-	internal_PREDICT_ACK [i] = ((reg_UPDATE_FETCH_PREDICTION_TABLE [context][top]._state == UPDATE_FETCH_PREDICTION_STATE_EMPTY) and
-   				    (reg_EVENT_STATE [context] == EVENT_STATE_OK) and
-//                                  (reg_UFPT_NB_UPDATE [context] == 0) and
-                                    is_accurate);
-
-
- 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ACK         : %d",internal_PREDICT_ACK [i]);
-	PORT_WRITE(out_PREDICT_ACK [i], internal_PREDICT_ACK [i]);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp	(revision 122)
@@ -40,17 +40,20 @@
         //     include ]DEPTH_MIN:DEPTH_MAX] -> speculative
 
-        PORT_WRITE(out_DEPTH_VAL     [i],((reg_UPDATE_PREDICTION_TABLE [i][reg_UPT_TOP [i]]._state == UPDATE_PREDICTION_STATE_EMPTY) 
-                                          and (reg_EVENT_STATE [i] == EVENT_STATE_OK)
+        uint32_t bottom = reg_UPT_BOTTOM [i];
+        uint32_t top    = reg_UPT_TOP    [i];
+        bool     empty  = reg_UPT_EMPTY [i];
+
+        // Depth_val is set when state is ok and the UPT[top] is empty
+        PORT_WRITE(out_DEPTH_VAL     [i],((reg_UPDATE_PREDICTION_TABLE [i][top]._state == UPDATE_PREDICTION_STATE_EMPTY) 
+                                          and (reg_UFPT_EVENT_STATE [i] == UFPT_EVENT_STATE_OK)
+                                          and (reg_UPT_EVENT_STATE  [i] == UPT_EVENT_STATE_OK)
                                           ));
 	if (_param->_have_port_depth)
           {
-        PORT_WRITE(out_DEPTH_CURRENT [i], reg_UPT_TOP    [i]);
-        PORT_WRITE(out_DEPTH_MIN     [i], reg_UPT_BOTTOM [i]);
-	PORT_WRITE(out_DEPTH_MAX     [i], reg_UPT_TOP    [i]);
-          }
-	PORT_WRITE(out_DEPTH_FULL    [i], not reg_UPT_EMPTY [i] and (reg_UPT_TOP [i] == reg_UPT_BOTTOM [i]));
-
-//         bool empty = reg_UPT_EMPTY [i];
-// 	PORT_WRITE(out_DEPTH_MAX     [i], ((empty)?reg_UPT_BOTTOM [i]:((reg_UPT_TOP [i]==0)?(_param->_size_upt_queue[i]-1):(reg_UPT_TOP [i]-1))));
+        PORT_WRITE(out_DEPTH_CURRENT [i], top);
+        PORT_WRITE(out_DEPTH_MIN     [i], bottom);
+	PORT_WRITE(out_DEPTH_MAX     [i], top);
+          }
+	PORT_WRITE(out_DEPTH_FULL    [i], not empty and (top == bottom));
       }
 
@@ -58,65 +61,62 @@
     // =====[ UPDATE ]====================================================
     // ===================================================================
-
-    bool     retire_ras_from_ufpt [_param->_nb_context]; // event ufpt -> restore RAS, else update upt
-    bool     retire_ras_from_upt  [_param->_nb_context]; // event upt  -> restore RAS, else restore others structure
-//  bool     have_event           [_param->_nb_context];
-    bool     ufpt_update          [_param->_nb_context];
-    bool     upt_update           [_param->_nb_context];
-    Tdepth_t tab_ufpt_depth       [_param->_nb_context];
-    Tdepth_t tab_upt_depth        [_param->_nb_context];
-
-    for (uint32_t i=0; i<_param->_nb_context; i++)
-      {
-        event_state_t event_state = reg_EVENT_STATE [i];
-
-        retire_ras_from_ufpt [i] = ((event_state == EVENT_STATE_MISS_FLUSH_UFPT         ) or
-                                    (event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT ) or
-                                    (event_state == EVENT_STATE_EVENT_FLUSH_UFPT        ) or
-                                    (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT));
-        retire_ras_from_upt  [i] = ((event_state == EVENT_STATE_MISS_FLUSH_UPT) or
-                                    (event_state == EVENT_STATE_EVENT_FLUSH_UPT));
-
-//         have_event           [i] = (event_state == EVENT_STATE_EVENT_FLUSH_UPT);
-
-        ufpt_update          [i] = true;
-        upt_update           [i] = true;
-        tab_ufpt_depth       [i] = reg_UFPT_UPDATE [i];
-        tab_upt_depth        [i] = reg_UPT_UPDATE  [i];
-      }
+    {
+      bool     flush_ufpt      [_param->_nb_context]; // event ufpt -> restore RAS, else update upt
+      bool     flush_upt       [_param->_nb_context]; // event upt  -> restore RAS, else restore others structure
+      bool     ufpt_can_update [_param->_nb_context];
+      bool     upt_can_update  [_param->_nb_context];
+      Tdepth_t tab_ufpt_depth  [_param->_nb_context];
+      Tdepth_t tab_upt_depth   [_param->_nb_context];
+      
+      // Init 
+      for (uint32_t i=0; i<_param->_nb_context; i++)
+        {
+          ufpt_event_state_t ufpt_event_state = reg_UFPT_EVENT_STATE [i];
+          upt_event_state_t  upt_event_state  = reg_UPT_EVENT_STATE [i];
+          
+          flush_ufpt      [i] = (ufpt_event_state == UFPT_EVENT_STATE_KO_FLUSH);
+          flush_upt       [i] = ((upt_event_state == UPT_EVENT_STATE_KO_MISS_FLUSH_UPT) or
+                                 (upt_event_state == UPT_EVENT_STATE_KO_EVENT_FLUSH_UPT));
+          ufpt_can_update [i] = true;
+          upt_can_update  [i] = true;
+          tab_ufpt_depth  [i] = reg_UFPT_UPDATE [i];
+          tab_upt_depth   [i] = reg_UPT_UPDATE  [i];
+        }
 
     for (uint32_t i=0; i<_param->_nb_inst_update; i++)
       {
-	Tcontext_t          context     = (reg_UPDATE_PRIORITY+i)%_param->_nb_context;
+	Tcontext_t          context              = (reg_UPDATE_PRIORITY+i)%_param->_nb_context;
 
 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * UPDATE [%d] (genMoore)",i);
 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context         : %d",context);
-	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * event_state     : %s",toString(reg_EVENT_STATE [context]).c_str());
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * flush_ufpt      : %d",flush_ufpt[context]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * flush_upt       : %d",flush_upt [context]);
 
         Tcontrol_t          val                  = false;
         Tcontrol_t          val_without_ack      = false;
-        Tcontrol_t          miss_prediction      ;
-        Tcontrol_t          direction_good       ;
-        Tcontrol_t          prediction_ifetch    ;
-        Tcontrol_t          btb_val              ;
-        Taddress_t          btb_address_src      ;
-        Taddress_t          btb_address_dest     ;
-        Tbranch_condition_t btb_condition        ;
-        Tcontrol_t          dir_val              ;
-        Thistory_t          dir_history          ;
-        Tcontrol_t          ras_val              ;
-        Tcontrol_t          ras_flush            ;
-        Tcontrol_t          ras_push             ;
-        Taddress_t          ras_address          ;
-        Tptr_t              ras_index            ;
+        Tcontrol_t          miss_prediction      = 0; // not necessary init
+        Tcontrol_t          direction_good       = 0; // not necessary init
+        Tcontrol_t          prediction_ifetch    = 0; // not necessary init
+        Tcontrol_t          btb_val              = 0; // not necessary init
+        Taddress_t          btb_address_src      = 0; // not necessary init
+        Taddress_t          btb_address_dest     = 0; // not necessary init
+        Tbranch_condition_t btb_condition        = 0; // not necessary init
+        Tcontrol_t          dir_val              = 0; // not necessary init
+        Thistory_t          dir_history          = 0; // not necessary init
+        Tcontrol_t          ras_val              = 0; // not necessary init
+        Tcontrol_t          ras_flush            = 0; // not necessary init
+        Tcontrol_t          ras_push             = 0; // not necessary init
+        Taddress_t          ras_address          = 0; // not necessary init
+        Tptr_t              ras_index            = 0; // not necessary init
 
         // Test if update fetch prediction table need update port
-        if (retire_ras_from_ufpt [context])
-          {
-            if (ufpt_update [context])
+        if (flush_ufpt [context])
+          {
+            if (ufpt_can_update [context])
               {
                 // Update Fetch Prediction Table
-                // An update of ufpt is to previous miss. Just restore Return Address Stack
-                
+                // An update of ufpt is to previous miss. Just restore Prediction_unit
+                
+                // Read information
                 Tdepth_t            depth     = tab_ufpt_depth[context];
                 ufpt_state_t        state     = reg_UPDATE_FETCH_PREDICTION_TABLE [context][depth]._state; 
@@ -131,5 +131,5 @@
 //              val_without_ack       = not update_ras(condition);
 
-                miss_prediction       = 1;
+                miss_prediction       = 1; // need update, also previous miss
 //              direction_good        = ;
                 prediction_ifetch     = 1;
@@ -138,9 +138,8 @@
 //              btb_address_dest      = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest;
 //              btb_condition         = condition;
-                dir_val               = update_ras(condition);
+                dir_val               = update_dir(condition);
                 dir_history           = reg_UPDATE_PREDICTION_TABLE [context][depth]._history;
-                // repop/ repush data -> don't corrupt ras
-                ras_val               = update_ras(condition); 
-                ras_flush             = 0;
+                ras_val               = update_ras(condition); // repop/ repush data -> don't corrupt ras
+                ras_flush             = 0; // no ras corruption
                 ras_push              = push_ras(condition);
                 ras_address           = reg_UPDATE_FETCH_PREDICTION_TABLE [context][depth]._address_ras;
@@ -153,15 +152,17 @@
                 // Warning : don't update same entry
                 if (depth == reg_UFPT_BOTTOM[context])
-                  ufpt_update [context] = false;
-                
-                tab_ufpt_depth[context] = ((depth==0)?_param->_size_ufpt_queue[context]:depth)-1;
+                  ufpt_can_update [context] = false;
+                else
+                  // update pointer
+                  tab_ufpt_depth[context] = ((depth==0)?_param->_size_ufpt_queue[context]:depth)-1;
               }
           }
         else
           {
-            if (upt_update [context])
+            if (upt_can_update [context])
               {
                 // Update Prediction Table
-                
+
+                // Read information
                 Tdepth_t            depth     = tab_upt_depth[context];
                 upt_state_t         state     = reg_UPDATE_PREDICTION_TABLE [context][depth]._state; 
@@ -174,26 +175,20 @@
                 log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * condition       : %s",toString(condition).c_str());
               
-                Tcontrol_t          state_is_ok_ko           = ((state == UPDATE_PREDICTION_STATE_OK   ) or
-                                                                (state == UPDATE_PREDICTION_STATE_KO   ));
-//                 Tcontrol_t          state_is_event           = ((state == UPDATE_PREDICTION_STATE_KO   ) or
-//                                                                 (state == UPDATE_PREDICTION_STATE_EVENT)//  or
-//                                                                 ((have_event[context])?(state == UPDATE_PREDICTION_STATE_OK):false)
-//                                                                 );
-                
-//                 Tcontrol_t          state_is_event_update    = state_is_event and     need_update(condition);
-//                 Tcontrol_t          state_is_event_no_update = state_is_event and not need_update(condition);
-
-                if (retire_ras_from_upt [context])
+                // is the valid branch (valid branch hit, or valid branch miss)
+                Tcontrol_t          state_is_ok_ko = ((state == UPDATE_PREDICTION_STATE_OK   ) or
+                                                      (state == UPDATE_PREDICTION_STATE_KO   ));
+
+                if (not flush_upt [context])
                   {
-//                 val                   = state_is_event_update;
-//                 val_without_ack       = state_is_event_no_update;
-                val                   = ((state == UPDATE_PREDICTION_STATE_KO   ) or 
-                                         ((state == UPDATE_PREDICTION_STATE_EVENT) and need_update(condition)));
-                val_without_ack       = ((state == UPDATE_PREDICTION_STATE_EVENT) and not need_update(condition));
+                    // no event, just update predictor
+                val                   = (state == UPDATE_PREDICTION_STATE_OK);
+                val_without_ack       = false;
                   }
                 else
                   {
-                val                   = (state == UPDATE_PREDICTION_STATE_OK);
-                val_without_ack       = false;
+                    // event, restore event (if need update)
+                val                   = ( (state == UPDATE_PREDICTION_STATE_KO   ) or 
+                                         ((state == UPDATE_PREDICTION_STATE_EVENT) and     need_update(condition)));
+                val_without_ack       = ( (state == UPDATE_PREDICTION_STATE_EVENT) and not need_update(condition));
                   }                  
 
@@ -205,9 +200,8 @@
                 btb_address_dest      = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest;
                 btb_condition         = condition;
-                dir_val               = // state_is_ok_ko and 
-                                        update_dir(condition); // if not ifetch, then static prediction
+                dir_val               = ifetch and update_dir(condition); // if not ifetch, then static prediction -> history is wrong
                 dir_history           = reg_UPDATE_PREDICTION_TABLE [context][depth]._history     ;
                 ras_val               = update_ras(condition); // repop/ repush data -> don't corrupt ras
-                ras_flush             = (state == UPDATE_PREDICTION_STATE_KO); // miss prediction, RAS is corrupted
+                ras_flush             = (state == UPDATE_PREDICTION_STATE_KO); // miss prediction on RAS -> RAS is corrupted
                 ras_push              = push_ras(condition);
                 // If corrupt, RAS must be flushed.
@@ -218,20 +212,23 @@
                 internal_UPDATE_FROM_UFPT [i] = false;
                 internal_UPDATE_DEPTH     [i] = depth;
-                internal_UPDATE_RAS       [i] = retire_ras_from_upt [context];
+                internal_UPDATE_RAS       [i] = flush_upt [context];
 
                 // Warning : don't update same entry
-                if (retire_ras_from_upt [context])
+                if (flush_upt [context])
                   {
-                    // Restore RAS. 
+                    // Stop condition
                     if ((depth == reg_UPT_BOTTOM[context]) or not (val or val_without_ack))
-                      upt_update [context] = false;
+                      upt_can_update [context] = false;
                     
+                    // flush -> ptr is decrease 
                     tab_upt_depth[context] = (depth==0)?(_param->_size_upt_queue[context]-1):(depth-1);
                   }
                 else
                   {
+                    // Stop condition
                     if ((depth == reg_UPT_TOP [context]) or not (val or val_without_ack))
-                      upt_update [context] = false;
+                      upt_can_update [context] = false;
                     
+                    // flush -> ptr is increase 
                     tab_upt_depth[context] = (depth+1)%_param->_size_upt_queue[context];
                   }
@@ -273,12 +270,16 @@
           }
       }
-    
+    }
+   
     // ===================================================================
     // =====[ BRANCH_EVENT ]==============================================
     // ===================================================================
+
+    // For all context ...
     for (uint32_t i=0; i<_param->_nb_context; i++)
       {
-	Tcontrol_t val = (reg_EVENT_STATE [i] == EVENT_STATE_UPDATE_CONTEXT);
-
+        // ... send an event if upt must be update the context
+	Tcontrol_t val = ((reg_UPT_EVENT_STATE [i] == UPT_EVENT_STATE_KO_DECODE_UPDATE_CONTEXT) or
+                          (reg_UPT_EVENT_STATE [i] == UPT_EVENT_STATE_KO_COMMIT_UPDATE_CONTEXT));
         PORT_WRITE(out_BRANCH_EVENT_VAL              [i],val);
         if (_param->_have_port_depth)
@@ -291,7 +292,9 @@
 	internal_BRANCH_EVENT_VAL [i] = val;
       }
+
       }
     else
       {
+        // Reset
         for (uint32_t i=0; i<_param->_nb_inst_update; i++)
           {
